%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% This program reads a given wake field from a ship. It generates
% a matrix that propose a duct which containes different duct 
% cross-sections. 
%
% The purpose is to achive a homogeneous inflow to the propeller.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clear all; close all; clc; 

wakedistribution = 'wake.xlsx'; %Reads the wake field.
OL = xlsread(wakedistribution);
A=OL(:,1:4); %Seperates the values from the file. Four sets of wake values.
B=OL(:,5); % This is the anglular positions.
C=OL(:,6); % Water velocity.


% Seperates the wake into sections of 30 degrees each:


degrees1=B<31;
dimension1=nonzeros(degrees1);
[colu1,row1]=size(dimension1);
[R1,C1]=find(degrees1);

degrees2=(B>31 & B<61);
dimension2=nonzeros(degrees2);
[colu2, row2]=size(dimension2);
[R2, C2]=find(degrees2);

degrees3=(B>61 & B<91);
dimension3=nonzeros(degrees3);
[colu3,row3]=size(dimension3);
[R3,C3]=find(degrees3);

degrees4=(B>91 & B<121);
dimension4=nonzeros(degrees4);
[colu4,row4]=size(dimension4);
[R4,C4]=find(degrees4);

degrees5=(B>121 & B<151);
dimension5=nonzeros(degrees5);
[colu5,row5]=size(dimension5);
[R5,C5]=find(degrees5);

degrees6=(B>151 & B<181);
dimension6=nonzeros(degrees6);
[colu6,row6]=size(dimension6);
[R6,C6]=find(degrees6);

degrees7=(B>181 & B<211);
dimension7=nonzeros(degrees7);
[colu7,row7]=size(dimension7);
[R7,C7]=find(degrees7);

degrees8=(B>211 & B<241);
dimension8=nonzeros(degrees8);
[colu8,row8]=size(dimension8);
[R8,C8]=find(degrees8);

degrees9=(B>241 & B<271);
dimension9=nonzeros(degrees9);
[colu9,row9]=size(dimension9);
[R9,C9]=find(degrees9);

degrees10=(B>271 & B<301);
dimension10=nonzeros(degrees10);
[colu10,row10]=size(dimension10);
[R10,C10]=find(degrees10);

degrees11=(B>301 & B<331);
dimension11=nonzeros(degrees11);
[colu11,row11]=size(dimension11);
[R11,C11]=find(degrees11);

degrees12=(B>331 & B<359); 
dimension12=nonzeros(degrees12);
[colu12,row12]=size(dimension12);
[R12,C12]=find(degrees12);

% Finding the comprimized matrix, which has meanvalues distributed on each
% seaction, per radii:

temp1=mean(A(R1,:));
temp2=mean(A(R2,:));
temp3=mean(A(R3,:));
temp4=mean(A(R4,:));
temp5=mean(A(R5,:));
temp6=mean(A(R6,:));
temp7=mean(A(R7,:));
temp8=mean(A(R8,:));
temp9=mean(A(R9,:));
temp10=mean(A(R10,:));
temp11=mean(A(R11,:));
temp12=mean(A(R12,:));

tempDegrees=(30:30:360)';

newwake=[temp1; temp2; temp3; temp4; temp5; temp6; temp7; temp8; temp9; temp10; temp11; temp12];

newWakeDistribution=[newwake tempDegrees]; %The wake is averaged over the section

%Finding maximum velocity at the propeller. Want to use this value all over
%the propeller. 

AA=newwake(:,1:4);
radii=AA(:,2:3); %Finding the value at 0.7*Radii.
tempave=mean(radii,2); %Average over the radii at r=0.7. 
[value, location] = max(tempave(:)); %Finding maximum value at r=0.7

bbccc=value-tempave; %The velocity the duct profiles should accelerate.
[bbccc tempDegrees];
%bbd=(tempave/value)*100;  %Finding the difference (per cent).

%Find the position to the duct profiles.  
    
    duct1=bbccc>1.8 & bbccc<=2.0;
    dimens1=nonzeros(duct1);
  
    duct2=bbccc>1.6 & bbccc<=1.8;
    dimens2=nonzeros(duct2);

    duct3=bbccc>1.4 & bbccc<=1.60;
    dimens3=nonzeros(duct3);
   
    duct4=bbccc>1.20 & bbccc<=1.40;
    dimens4=nonzeros(duct4);
    
    duct5=bbccc>1.0 & bbccc<=1.20;
    dimens5=nonzeros(duct5);
    
    duct6=bbccc>0.8 & bbccc<=1.0;
    dimens6=nonzeros(duct6);
    
    duct7=bbccc>0.6 & bbccc<=0.8;
    dimens7=nonzeros(duct7);
     
    duct8=bbccc>0.4 & bbccc<=0.6;
    dimens8=nonzeros(duct8);
    
    duct9=bbccc>0.2 & bbccc<=0.4;
    dimens9=nonzeros(duct9);
   
    duct10=bbccc>=0 & bbccc<=0.2;
    dimens10=nonzeros(duct10);
   
    %nywake22=[dyse(i)]
    newwake2=[duct1 duct2 duct3 duct4 duct5 duct6 duct7 duct8 duct9 duct10];
   
    % Generates the matrix that is placing the ducts.
    placementOfDuctCrossSection=[newwake2 tempDegrees]
    ductCrossSectionNumber=[1 2 3 4 5 6 7 8 9 10]
  